create or replace function pgq.event_failed(
    x_batch_id bigint,
    x_event_id bigint,
    x_reason text)
returns integer as $$
declare
    sql        text;
begin
    insert into pgq.failed_event (queue_id, consumer_id, batch_id, event_id,
        retry_count, failure_reason, creation_date,
        ref_id, payload, producer)
    select b.queue_id, b.consumer_id, b.batch_id, ev.event_id,
           coalesce(ev.retry_count, 0), x_reason, ev.creation_date,
           ev.ref_id, ev.payload, ev.producer
      from pgq.fetch_batch_events(x_batch_id) ev,
           pgq.active_batch b
     where b.batch_id = x_batch_id
       and ev.event_id = x_event_id;
    if not found then
        raise exception 'event not found';
    end if;
    return 1;

-- dont worry if the event is already in queue
exception
    when unique_violation then
        return 0;
end;
$$ language plpgsql security definer;

