--
-- Info about queues
--

create or replace function pgq.get_queue_list()
returns setof pgq.ret_queue_list as $$
declare
    rec pgq.ret_queue_list%rowtype;
begin
    for rec in 
        select q.queue_name, q.rotation_delay, q.number_of_event_tables,
               -- q.tick_max_amount, q.tick_max_lag, q.tick_idle_interval,
               -- q.external_ticker, q.creation_date,
               NULL,
               (select current_timestamp - t.tick_time
                  from pgq.tick t where t.queue_id = q.queue_id
                 order by t.queue_id desc, t.tick_id desc limit 1
                ) as ticker_lag
          from pgq.queue_config q
         order by 1
    loop
        return next rec;
    end loop;
    return;
end;
$$ language plpgsql security definer;

