create or replace function pgq.unregister_consumer(
    x_queue_name text,
    x_consumer_name text)
returns integer as $$
declare
    cf            record;
    x_consumer_id integer;
begin
    select consumer_id into x_consumer_id
        from pgq.consumer
        where consumer_name = x_consumer_name;
    if not found then
        raise exception 'No such consumer: %', x_consumer_name;
    end if;

    select * from pgq.queue_config into cf
        where queue_name = x_queue_name;
    if not found then
        raise exception 'No such queue: %', x_queue_name;
    end if;

    delete from pgq.retry_event
        where queue_id = cf.queue_id
          and consumer_id = x_consumer_id;

    delete from pgq.failed_event
        where queue_id = cf.queue_id
          and consumer_id = x_consumer_id;

    delete from pgq.batch_log
        where queue_id = cf.queue_id
          and consumer_id = x_consumer_id;

    delete from pgq.active_batch
        where consumer_id = x_consumer_id
          and queue_id = cf.queue_id;

    delete from pgq.high_watermark
        where consumer_id = x_consumer_id
          and queue_id = cf.queue_id;

    return 1;
end;
$$ language plpgsql security definer;

